#include <stdlib.h>
#include <assert.h>
#include "pile.h"

struct pile
{
  int *tab;
  int taille;
  int nb;
};

pile *creer_pile()
{
  pile *p = (pile*)malloc(sizeof(pile));
  p->taille = 1;
  p->tab = (int*)malloc(p->taille * sizeof(int));
  p->nb = 0;
  return p;
}

bool pile_est_vide(pile *p)
{
  return p->nb == 0;
}

void empiler(pile *p, int val)
{
  if (p->nb == p->taille)
  {
    p->taille = 2 * p->taille + 1;
    int *new_tab = (int*)malloc(p->taille * sizeof(int));
    for (int i = 0; i < p->nb; i++)
    {
      new_tab[i] = p->tab[i];
    }
    free(p->tab);
    p->tab = new_tab;
  }
  p->tab[p->nb] = val;
  p->nb++;
}

int sommet(pile *p)
{
  assert(!pile_est_vide(p));
  return p->tab[p->nb - 1];
}

int depiler(pile *p)
{
  int x = sommet(p);
  p->nb--;
  return x;
}

void detruire_pile(pile *p)
{
  free(p->tab);
  free(p);
}
